#import "smslib.h"
#import "SMSlib_sms.h"

NSAutoreleasePool * pool;

/*
 * Class:     SMSlib_sms
 * Method:    readSMS
 * Signature: ()[F
 */
JNIEXPORT jfloatArray JNICALL Java_SMSlib_sms_readSMS
  (JNIEnv *env, jclass this){
  
  	sms_acceleration accel;
  	
	int ok = smsGetData(&accel);
    if (ok) 
		return false;
	
  
  	jfloatArray jr;
	jsize rlen = 3;
	jr = (*env)->NewFloatArray(env, rlen);

	int size = 3;
	float *data;
	
	data = (float *)malloc(sizeof(float)*size);
	data[0] = accel.x;
	data[1] = accel.y;
	data[2] = accel.z;
	(*env)->SetFloatArrayRegion(env,jr, 0, size, data);
	free(data);
	return jr;

}


/*
 * Class:     SMSlib_sms
 * Method:    startup
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_SMSlib_sms_startup
  (JNIEnv *env, jclass this){
	
  	int result;
  	jint ret;
  	
  	pool = [[NSAutoreleasePool alloc] init];

  	result = smsStartup(nil, nil);
	ret = result;
	return ret;
  
}

/*
 * Class:     SMSlib_sms
 * Method:    calibrate
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_SMSlib_sms_calibrate
  (JNIEnv *env, jclass this){
	
	jboolean res = JNI_FALSE;
	if (smsLoadCalibration())
		res = JNI_TRUE;
	return res;
	
}


/*
 * Class:     SMSlib_sms
 * Method:    shutdown
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_SMSlib_sms_shutdown
  (JNIEnv *env, jclass this){
  	smsShutdown();
  	[pool release];

}

/*
 * Class:     SMSlib_sms
 * Method:    caliDesc
 * Signature: ()Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_SMSlib_sms_caliDesc
  (JNIEnv *env, jclass this){
  
	NSString *desc = smsGetCalibrationDescription();
	
	jsize buflength = [desc length];
	unichar buffer[buflength];
	[desc getCharacters:buffer];
	jstring javaStr = (*env)->NewString(env, (jchar *)buffer, buflength);

	
	return javaStr;
  
  
  }



